/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-26 16:27:34 UTC)
 * on 2013-07-15 at 20:03:11 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.androidpublisher.model;

/**
 * A Purchase resource indicates the status of a user's subscription purchase.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Play Android Developer API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class InappPurchase extends com.google.api.client.json.GenericJson {

  /**
   * The consumption state of the inapp product. Possible values are: - - Consumed  - - Yet to be
   * consumed
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Integer consumptionState;

  /**
   * A developer-specified string that contains supplemental information about an order.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String developerPayload;

  /**
   * This kind represents a inappPurchase object in the androidpublisher service.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * The purchase state of the order. Possible values are: - - Purchased  - - Cancelled
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Integer purchaseState;

  /**
   * The time the product was purchased, in milliseconds since the epoch (Jan 1, 1970).
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.lang.Long purchaseTime;

  /**
   * The consumption state of the inapp product. Possible values are: - - Consumed  - - Yet to be
   * consumed
   * @return value or {@code null} for none
   */
  public java.lang.Integer getConsumptionState() {
    return consumptionState;
  }

  /**
   * The consumption state of the inapp product. Possible values are: - - Consumed  - - Yet to be
   * consumed
   * @param consumptionState consumptionState or {@code null} for none
   */
  public InappPurchase setConsumptionState(java.lang.Integer consumptionState) {
    this.consumptionState = consumptionState;
    return this;
  }

  /**
   * A developer-specified string that contains supplemental information about an order.
   * @return value or {@code null} for none
   */
  public java.lang.String getDeveloperPayload() {
    return developerPayload;
  }

  /**
   * A developer-specified string that contains supplemental information about an order.
   * @param developerPayload developerPayload or {@code null} for none
   */
  public InappPurchase setDeveloperPayload(java.lang.String developerPayload) {
    this.developerPayload = developerPayload;
    return this;
  }

  /**
   * This kind represents a inappPurchase object in the androidpublisher service.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * This kind represents a inappPurchase object in the androidpublisher service.
   * @param kind kind or {@code null} for none
   */
  public InappPurchase setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * The purchase state of the order. Possible values are: - - Purchased  - - Cancelled
   * @return value or {@code null} for none
   */
  public java.lang.Integer getPurchaseState() {
    return purchaseState;
  }

  /**
   * The purchase state of the order. Possible values are: - - Purchased  - - Cancelled
   * @param purchaseState purchaseState or {@code null} for none
   */
  public InappPurchase setPurchaseState(java.lang.Integer purchaseState) {
    this.purchaseState = purchaseState;
    return this;
  }

  /**
   * The time the product was purchased, in milliseconds since the epoch (Jan 1, 1970).
   * @return value or {@code null} for none
   */
  public java.lang.Long getPurchaseTime() {
    return purchaseTime;
  }

  /**
   * The time the product was purchased, in milliseconds since the epoch (Jan 1, 1970).
   * @param purchaseTime purchaseTime or {@code null} for none
   */
  public InappPurchase setPurchaseTime(java.lang.Long purchaseTime) {
    this.purchaseTime = purchaseTime;
    return this;
  }

  @Override
  public InappPurchase set(String fieldName, Object value) {
    return (InappPurchase) super.set(fieldName, value);
  }

  @Override
  public InappPurchase clone() {
    return (InappPurchase) super.clone();
  }

}
